c     program gemsp09 calculates cs\pm1 spectra and gaps.
c     input files gemo.datin and enl.coeff are (commented) at the end
c     The otput is similar to that of  The Nuclear Monopole Hamiltonian,
c      J. Duflo and A. P. Zuker,
c      Phys.  Rev.  C {\bf 59}, 2347R (1999).
c     There are very minor differences with respect to the published
c     numbers.  
c     The important program is gemo, which can be used to calculate the
c     monopole energy of a given configuration, to within LD type contributions
c     not included.   
      implicit real*8(A-H,O-Z)
      parameter(lp=9,lpp=(lp+1)*(lp+1)-1,lifill=36,lcoef=48,leps=100)
      dimension ifillz(lifill),ifilln(lifill),nocn(0:lpp),nocz(0:lpp)
      dimension  coef(lcoef),dyda(lcoef)
      dimension eps(leps),epsi(leps), iorbit(leps),ii(leps),jis(leps),
     $     w1(0:leps,0:leps),eps1(leps),eps13(leps)

      data ifillz/0,11,1,22,2,12,33, 23,13,3,44, 34,24,14,4,55,
     $     45,35,66,15,25,5, 46,26,6,16,36,56,77,57,37,17,7,27,47,67/

      data ifilln/0,11,1,22,2,12,33, 13,3,23,44,  24,34,55,14,4, 
     $     45,35,66,15,25,5, 46,26,6,16,36,56,77,57,37,17,7,27,47,67/
      
c     throughout the program, any name ending in n is a neutron quantity,
c     and any name ending in z is a proton quantity.
c     in ifill, the number I=(lp+1)*j+i corresponds to state with 
c     truej=tj=j+1/2, and p=i.
c     I is the linear position of element (i,j), in array A(i,j). 
      open(unit=10,file='gemo.datin')!input
      open(unit=11,file='goutn')
      open(unit=12,file='gapoutn')
      open(unit=16,file='enl.coeff')!input
      read(16,99)coef
      write(6,'(6f10.5)')coef
      rewind (16)
c     Typical gemo.datin looks like
c     40 50  Z N
c     42 50 
c     44 50 
c     46 50 
c     48 -50 
C     This calculates \pm 1 states for Z=40,42,...,N=50
 99   format(6f10.5)
      idet=0                    ! for idet.ge.1 writes dyda(idet to idet+11) 
      iprot=1                   ! calculates(1), or does not(0) prot\pm 1
      ineutr=1                  !idem n
      ncon=1
      do while(ncon.gt.0)
         do i=0,lpp
            nocn(i)=0
            nocz(i)=0
         enddo
         iflag=1
         read(10,*)nz,nn
         na=0
c     write(11,*)
c     write(11,*)nz,nn 
c     write(11,*)nz,nn
         if(nn.lt.0)then
            nn=-nn
            ncon=-1
         endif
         i=0
         ncum=0   
         do while(ncum.lt.nn)
            i=i+1
            j=ifilln(i)/(lp+1)
            ip=mod(ifilln(i),lp+1)
            nocn(ifilln(i))=2*(j+1)
            ncum=ncum+nocn(ifilln(i))
         enddo
         nocn(ifilln(i))=nocn(ifilln(i))-ncum+nn
         jfn=j
         ipfn=ip
         ifern=i
         i=0
         ncum=0   
         do while(ncum.lt.nz)
            i=i+1
            j=ifillz(i)/(lp+1)
            ip=mod(ifillz(i),lp+1)
            nocz(ifillz(i))=2*(j+1)
            ncum=ncum+nocz(ifillz(i))
         enddo
         nocz(ifillz(i))=nocz(ifillz(i))-ncum+nz
         jfz=j
         ipfz=ip
         iferz=i
         call  gemo(na,nn,nz,nocn,nocz,lp,lpp,lcoef,coef,dyda,
     &        ener,iflag)        
         if(idet.ge.1) write(11,10)nz,nn,ener
 10      format('Z N ecs ',2i4,f12.5)
         if(idet.ge.1)  write(11,100)ip,(dyda(ll),ll=idet,idet+11)
         eclos=ener
c     now we calculate the \pm 1 states associated to nn,nz. n particles
c     first
         if(ineutr.ne.0.or.nn.eq.nz)then
            nn=nn+1
            if(jfn.eq.ipfn) then
               kmax=ipfn+2
            else
               kmax=ipfn+3
            endif
            do k=1,kmax
               nocn(ifilln(ifern+k))=1
               call  gemo(na,nn,nz,nocn,nocz,lp,lpp,lcoef,coef,dyda,
     &              ener,k)           
               eps(k)=ener
               iorbit (k)=ifilln(ifern+k)
               nocn(ifilln(ifern+k))=0
               if(idet.ge.1)write(11,100) iorbit(k),
     &              (dyda(ll), ll=idet,idet+11)
c     100         format(I2,2(f8.2),6(f6.2),2(f8.2))  
 100           format(I2,f10.2,11f6.2)  
            enddo
            call indexe(eps,ii,kmax)         
            epmax=eps(ii(kmax))
            if(idet.ge.1)  write(11,'(2i4,f10.3)') nz,nn,eps(ii(kmax))
            write(11,'(a26,2i5)') 'neutron particles for Z,N=',nz,nn
            epar=epmax
            do k=1,kmax
               eps(k)=epmax-eps(k)
            enddo
            do k=kmax,1,-1
               write(11,'(i4,f6.1)') iorbit(ii(k)),eps(ii(k))
            enddo
            nn=nn-1
c     now we do the same for the neutron hole states
            nn=nn-1
            if(jfn.eq.ipfn) then
               kmax=ipfn+1
            else               kmax=ipfn+2
            endif
            do k=1,kmax
               nocn(ifilln(ifern-k+1))=nocn(ifilln(ifern-k+1))-1
               call  gemo(na,nn,nz,nocn,nocz,lp,lpp,lcoef,coef,dyda,
     &              ener,k)            
               eps(k)=ener
               iorbit (k)=ifilln(ifern-k+1)
               nocn(ifilln(ifern-k+1))=nocn(ifilln(ifern-k+1))+1
               if(idet.ge.1) write(11,100) 
     &              iorbit(k),(dyda(ll), ll=idet,idet+11) 
            enddo
            call indexe(eps,ii,kmax)
            epmin=eps(ii(1))
            epmax=eps(ii(kmax))
            if(idet.ge.1)  write(11,'(2i4,2f12.3)') nz,nn,epmax, epmin
            write(11,'(a26,2i5)') 'neutron holes for Z,N=    ',nz,nn
            ehole=epmax
            do k=1,kmax
               eee=eps(k)-epmin
               epsi(k)=epmax-eps(k)
               eps(k)=eee
            enddo
            do k=1,kmax
               l=kmax-k+1
               write(11,'(i4,f6.1)') iorbit(ii(l)),epsi(ii(l))
            enddo
c     write(11,*)
c     do k=1,kmax
c     write(11,*) iorbit(ii(k)),eps(ii(k))
c     enddo
            nn=nn+1
            egap=2.0*eclos-epar-ehole
            write(12,'(2i4,10h n sp gap=f6.1)')nz,nn,egap
         endif
c     now repeat for protons if nn.ne.nz   z particles first
         if(nn.ne.nz.and.iprot.ne.0) then
            if(jfz.eq.ipfz) then
               kmax=ipfz+2
            else
               kmax=ipfz+3
            endif
            nz=nz+1
            do k=1,kmax
               nocz(ifillz(iferz+k))=1
               call  gemo(na,nn,nz,nocn,nocz,lp,lpp,lcoef,coef,dyda,
     &              ener,k)                   
               eps(k)=ener
               iorbit (k)=ifillz(iferz+k)
               nocz(ifillz(iferz+k))=0
               if(idet.ge.1) write(11,100) 
     &              iorbit(k),(dyda(ll), ll=idet,idet+11)
            enddo
            call indexe(eps,ii,kmax)
            epmax=eps(ii(kmax))
            epar=epmax
            if(idet.ge.1)write(11,'(2i4,f12.3)') nz,nn,eps(ii(kmax))
            write(11,'(a25,2i5)') 'proton particles for Z,N= ',nz,nn
            do k=1,kmax
               eps(k)=epmax-eps(k)
            enddo
            do  k=kmax,1,-1
               write(11,'(i4,f6.1)') iorbit(ii(k)),eps(ii(k))
            enddo
            nz=nz-1 
c     c     now we do the same for the proton hole states
            if(jfz.eq.ipfz) then
               kmax=ipfz+1
            else
               kmax=ipfz+2
            endif
            nz=nz-1
            do k=1,kmax
               nocz(ifillz(iferz-k+1))=nocz(ifillz(iferz-k+1))-1
               call  gemo(na,nn,nz,nocn,nocz,lp,lpp,lcoef,coef,dyda,
     &              ener,k)
               eps(k)=ener
               iorbit (k)=ifillz(iferz-k+1)
               nocz(ifillz(iferz-k+1))=nocz(ifillz(iferz-k+1))+1
               if(idet.ge.1) write(11,100) 
     &              iorbit(k),(dyda(ll), ll=idet,idet+11)
            enddo
            call indexe(eps,ii,kmax)
            epmin=eps(ii(1))
            epmax=eps(ii(kmax))
            ehole=epmax
            if(idet.ge.1)write(11,'(2i4,2f12.3)') nz,nn,epmax,epmin
            write(11,'(a25,2i5)') 'proton holes for Z,N=    ',nz,nn
            do k=1,kmax
               eee=eps(k)-epmin
               epsi(k)=epmax-eps(k)
               eps(k)=eee
            enddo
            do k=1,kmax
               l=kmax-k+1
               write(11,'(i4,f6.1)') iorbit(ii(l)),epsi(ii(l))
            enddo
c     write(11,*)            
c     do k=1,kmax
c     write(11,*) iorbit(ii(k)),eps(ii(k))
c     enddo
            nz=nz+1
            egap=2.0*eclos-epar-ehole
            write(12,'(2i4,10h z sp gap=f6.1)')nz,nn,egap 
         endif
      enddo
      end    
      subroutine indexe(A,I,N)
c     returns an array I(N) which lists the indices I of A(N) in
c     order of increasing A.
      implicit real*8(a-h,o-z)
      dimension a(n),i(n)
      do j=1,n
         i(j)=n-j+1
      enddo
      if (n.le.1) return
      mark=n+1
      do while (mark.gt.2)
c     at this point, the elements that need reordering are i(1)...i(mark-1)
         lim=mark-1
c     now initialize mark to 2, and investigate reordering needed.
c     if reordering is done, then mark will change accordingly
         mark=2
         do j=2,lim
            last=i(j-1)
            next=i(j)
            if(a(last).gt.a(next))then
               keep=i(j-1)
               i(j-1)=i(j)
               i(j)=keep
               mark=j
            endif
         enddo
c     i(n) has now the correct elements from i(mark) to i(n).
c     elements from i(1) to to i(mark-1) may need reordering
      enddo
      return
      end      
      subroutine gemo(na,nn,nz,nocn,nocz,kp,kpp,lcoef,coef,dyda,ener
     $     ,iem)
c     ax(i,j) contain coefficients for operators x= u,m,j,d,l...
c     axn(i) are the corresponding partial contributions for neutrons.
c     saxn are the sums of these contributions.
c     zni=intrashell nz, eei= intrashell nn+zz, znc, eec= cross shell terms.
c     so= one body term, ho=harmonic oscillator, fm=master term.
c     throughout the program, any name ending in n is a neutron quantity,
c     and any name ending in z is a proton quantity.
cc     ending in s  "self" for zncs, etc.
      implicit double precision (a-h,o-z)
      dimension nocn(0:kpp),nocz(0:kpp),coef(lcoef),dyda(lcoef)
      dimension au(0:9,0:9), am(0:9,0:9), ad(0:9,0:9), 
     &  al(0:9,0:9),al1(0:9,0:9),ad1(0:9,0:9),
     &  aj(0:9,0:9), as(0:9,0:9), av(0:9,0:9)
      dimension auz(0:9), amz(0:9), adz(0:9), alz(0:9), al1z(0:9),
     &  ajz(0:9), asz(0:9),avz(0:9),ad1z(0:9)
      dimension aun(0:9), amn(0:9), adn(0:9), aln(0:9), al1n(0:9),
     $     ajn(0:9), asn(0:9),avn(0:9),ad1n(0:9),non(48),noz(48)
      dimension dj(0:9), dk(0:9), dr(0:9), dp(0:9), ds(0:9) 
      dimension nx(2),s2(2),d2(2),s3(2)
c--------
      nx(1)=nz; nx(2)=nn
         do k=1,lcoef
              dyda(k)=0.
         enddo
      lp=9
      a=nn+nz
      a13=a**(1.d0/3.d0)
      a23=a13*a13
      t=abs(nn-nz)
       rc=a13*(1.0-0.25*(t/a)**2.0)
      a13=a13*(1.0-1.0*(t/a)**2.0)
      home=(1.d0/a13)*dexp(-3.5d0/a)
      do i=0,lp
         p=i
         d=(p+1)*(p+2)
         dp(i)=d
         dr(i)=p*(p+1.)
         ds(i)=p*(p-1.)
         dj(i)=2.*(p+1.)
         dk(i)=2.*(p)
cc master ho ls
         do j=0,i
            l=j+mod(i+j,2)
            dl=l
            au(i,j)=1.d0
            am(i,j)=1.d0/dsqrt(d) 
            if(j.eq.l) then
               ad(i,j)=dl/(dl+.5d0)
            else
               ad(i,j)=-(dl+1.d0)/(dl+.5d0)
            endif
            if(l.eq.p) then
               ad1(i,j)=0.d0
            else
               fad1=(dl+0.5d0)/(p+1.5d0)
               ad1(i,j)=ad(i,j)*fad1
            endif
            ad(i,j)=ad(i,j)*(dl+.5d0)/(p+1.5d0)
cc ll and variants
            al(i,j)=0.d0
            if(i.gt.1)then
               al(i,j)=2.d0*(dl*(dl+1.d0)-0.5d0*p*(p+3.d0))/d  
            endif
            al1(i,j)=0.d0
            if(i.gt.3)then
               if(i.ne.l) al1(i,j)=2.d0*(dl*(dl+1.d0)-0.5d0*(p+1.0
     $                 )*(p-2.d0))/d
            endif
cc as, av and others
            if(i.eq.j) then
               aj(i,j)=1.d0/(2.d0*(p+1.d0))
               as(i,j)=p/(p+2.0)
            else
               aj(i,j)=0.d0
               as(i,j)=-2.d0/(p+2.d0)
            endif
            if(j.eq.i-1)then
               av(i,j)=(p-1.0)/sqrt(d)
            else
               av(i,j)=-2.0/sqrt(d)
            endif
            if(i.eq.j) av(i,j)=0.0
         enddo
      enddo
c     now we multiply them by the contents of noc arrays.
              jz=0
              jn=0
              son=0.
         do i=0,lp
             p=i
            aun(i)=0.d0
            amn(i)=0.d0
            adn(i)=0.d0
            ad1n(i)=0.d0
            aln(i)=0.d0
            al1n(i)=0.d0
            ajn(i)=0.d0
            asn(i)=0.d0
            avn(i)=0.d0
            auz(i)=0.d0
            amz(i)=0.d0
            adz(i)=0.d0
            ad1z(i)=0.d0
            alz(i)=0.d0
            al1z(i)=0.d0
            ajz(i)=0.d0
            asz(i)=0.d0
            avz(i)=0.d0

            do j=0,i
               ocn=nocn((lp+1)*j+i)
               ocz=nocz((lp+1)*j+i)
               son=son+ocn
               if(ocz.ne.0)then
                  jz=jz+1
                  noz(jz)=ocz
               endif
               if(ocn.ne.0)then
                  jn=jn+1
                  non(jn)=son
               endif
               aun(i)=aun(i)+au(i,j)*ocn
               amn(i)=amn(i)+am(i,j)*ocn
               adn(i)=adn(i)+ad(i,j)*ocn              
               ad1n(i)=ad1n(i)+ad1(i,j)*ocn
               aln(i)=aln(i)+al(i,j)*ocn
               al1n(i)=al1n(i)+al1(i,j)*ocn
               ajn(i)=ajn(i)+aj(i,j)*ocn
               asn(i)=asn(i)+as(i,j)*ocn
               avn(i)=avn(i)+av(i,j)*ocn
               amz(i)=amz(i)+am(i,j)*ocz
               auz(i)=auz(i)+au(i,j)*ocz
               adz(i)=adz(i)+ad(i,j)*ocz
               ad1z(i)=ad1z(i)+ad1(i,j)*ocz
               alz(i)=alz(i)+al(i,j)*ocz
               al1z(i)=al1z(i)+al1(i,j)*ocz
               ajz(i)=ajz(i)+aj(i,j)*ocz
               asz(i)=asz(i)+as(i,j)*ocz
               avz(i)=avz(i)+av(i,j)*ocz
            enddo
         enddo

c     now it remains to construct the final expressions               
         comn=0.d0                                                    
         comz=0.d0                                                    
         hon=0.d0                                                     
         hoz=0.d0                                                     
         fmn=0.d0                                                     
         fmz=0.d0                                                     
         sodn=0.d0                                                    
         sodz=0.d0
         sod1n=0.d0                                                    
         sod1z=0.d0                                                    
         soln=0.d0                                                    
         solz=0.d0
         sol1n=0.d0                                                    
         sol1z=0.d0
         sasn=0.d0
         sasz=0.d0                                                   
         saln=0.d0                                                   
         salz=0.d0
         savn=0.d0                                                    
         savz=0.d0
         eecls=0.0
         zncvs=0.d0
         znil1=0.d0
         znyd=0.d0
         znyl=0.d0
         eeys=0.d0 
         do i=0,lp                                                    
            p=i                                                       
            if(i.eq.0)p=0.00001                                       
c master and ho                                                       
            d=(p+1.)*(p+2.)                                        
            den=p+1.5d0                                            
            sqd=dsqrt(den)                                         
            comn=comn+aun(i)/d                                     
            comz=comz+auz(i)/d                                     
            fmn=fmn+amn(i)                                         
            fmz=fmz+amz(i)                                         
            hon=hon+aun(i)*den!dsqrt(d) !den  
            hoz=hoz+auz(i)*den!dsqrt(d) !*den                     
c spin orbit
            soln=soln+aln(i)*(p-3.)/(den)
            solz=solz+alz(i)*(p-3.)/(den)
            sodn=sodn+adn(i)*den/(p+2.)
            sodz=sodz+adz(i)*den/(p+2.)
            sol1n=sol1n+al1n(i)*(p-3.)/den        
            sol1z=sol1z+al1z(i)*(p-3.)/den
            sod1n=sod1n+ad1n(i)
            sod1z=sod1z+ad1z(i)                                       
c     intra terms                                                     
            ten=((p+1.)*(p+2.)-aun(i))/((p+1.)*(p+2.)-1.)          
            ten=ten*p/(p+2.)                                       
            eeys=eeys+(asn(i)-ten)*ajn(i)                            
            tez=((p+1.)*(p+2.)-auz(i))/((p+1.)*(p+2.)-1.)
            tez=tez*p/(p+2.)                                       
            eeys=eeys+(asz(i)-tez)*ajz(i)
            znyd =znyd +(ajn(i)*adz(i)+ajz(i)*adn(i))          
            znil1 =znil1 +(al1n(i)*asz(i)+al1z(i)*asn(i))/den
            znyl =znyl +(aln(i)*ajz(i)+alz(i)*ajn(i)) !*d/p/(p+1)
c     sums for use in cross terms
            sasn=sasn+asn(i)/sqd                                   
            sasz=sasz+asz(i)/sqd
            savn=savn+avn(i)/sqd
            savz=savz+avz(i)/sqd 
            saln=saln+aln(i)/sqd                                
            salz=salz+alz(i)/sqd                                   
c     self energies of cross terms
            eecls=eecls+(aln(i)*aln(i)+alz(i)*alz(i))/den
            zncvs=zncvs+(avn(i)*asz(i)+avz(i)*asn(i))/den
            enddo
cccc  Look just above endo. Make sure counter-term is OK  
            zncv=savn*sasz+savz*sasn-zncvs 
            eecl=saln*saln+salz*salz-eecls           
            ho=hon+hoz                                                
            gm=(fmn+fmz)**2-comn-comz                                 
            sod=sodn+sodz                                           
            sod1=sod1n+sod1z 
            sol=soln+solz 
            sol1=sol1n+sol1z                                            
            tt1=-1.d0/a23                                             
            tt13=1.d0/a23/a13                                         
            dyda(34)=t*(t+2)*(tt1)
            dyda(35)=t*(t+2)*(tt13)
            dyda(36) =-z2*(1./rc-1./a) !coulomb / fit des coulombiens(12/97)
            dyda(1)=gm-2.d0*ho+2.*sod+2.*sol     
            dyda(2)=2.*sod+2.*sod1-2*sol1                    
            dyda(3)=2.*zncv+eecl
            dyda(4)=eeys
            dyda(5)=znyl-znil1
            dyda(6)=znyd
cccccccccccc  
            do jk=1,lcoef
               dyda(jk)=dyda(jk)*home
            enddo            
            ener=0.
            do jk=1,lcoef
               ener=ener+coef(jk)*dyda(jk)
            enddo 
c-------------
            do jk=1,lcoef       !for printing purpose
               dyda(jk)=coef(jk)*dyda(jk)
            enddo
c-------------
            return
            end

cccccccccc
c  gemo.datin      
c    3    3
c    6    6
c    6    8
c    8    8
c    8   14 
c   14   14
c   20   20
c   20   28
c   28   28
c   28   40
c   28   50
c   40   40
c   40   50
c   50   50
c   50   82
c   82  -126
c  enl.coeff 
c      9.51987  -1.78851   3.60387   7.30598   8.35904  -2.16092
c      0.00000   0.00000   0.00000   0.00000   0.00000   0.00000
c      0.00000   0.00000   0.00000   0.00000   0.00000   0.00000
c      0.00000   0.00000   0.00000   0.00000   0.00000   0.00000
c      0.00000   0.00000   0.00000   0.00000   0.00000   0.00000
c      0.00000   0.00000   0.00000   0.00000   0.00000   0.00000
c      0.00000   0.00000   0.00000   0.00000   0.00000   0.00000
c      0.00000   0.00000   0.00000   0.00000   0.00000   0.00000
c    
